"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ck_lib_1 = require("@ckstack/ck-lib");
const DatabaseService_1 = __importDefault(require("./DatabaseService"));
class DatabaseWebService {
    static setActiveRedisCache(dbCacheRedisIndex, dbCacheAliveSec) {
        DatabaseService_1.default.setActiveRedisCache(dbCacheRedisIndex, dbCacheAliveSec);
    }
    static getCacheSingleDbRow_AOP(req, res, cacheName, TCreator, dbFilter, transaction, order) {
        return __awaiter(this, void 0, void 0, function* () {
            const { lhd, lang } = res.locals.lhd;
            const ret = yield DatabaseService_1.default.getCacheSingleDbRow(lhd, cacheName, TCreator, dbFilter, transaction, order, lang);
            return ret;
        });
    }
    static getCacheMultiDbRow_AOP(req, res, cacheName, TCreator, dbFilter, transaction, order) {
        return __awaiter(this, void 0, void 0, function* () {
            const { lhd, lang } = res.locals.lhd;
            const ret = yield DatabaseService_1.default.getCacheMultiDbRow(lhd, cacheName, TCreator, dbFilter, transaction, order, lang);
            return ret;
        });
    }
    static getCacheJoinDbRow_AOP(req, res, cacheKeyPrefix, cacheName, rdb, rawQuery, replacements, transaction) {
        return __awaiter(this, void 0, void 0, function* () {
            const { lhd, lang } = res.locals.lhd;
            const ret = yield DatabaseService_1.default.getCacheJoinDbRow(lhd, cacheKeyPrefix, cacheName, rdb, rawQuery, replacements, transaction, lang);
            return ret;
        });
    }
    static removeCacheAutoDbRow_AOP(req, res, TCreator, ids) {
        return __awaiter(this, void 0, void 0, function* () {
            const { lhd, lang } = res.locals.lhd;
            const ret = yield DatabaseService_1.default.removeCacheAutoDbRow(lhd, TCreator, ids, lang);
            return ret;
        });
    }
    static removeCacheDbRow_AOP(req, res, cacheName, TCreator, dbFilter, isMulti) {
        return __awaiter(this, void 0, void 0, function* () {
            const { lhd, lang } = res.locals.lhd;
            const ret = yield DatabaseService_1.default.removeCacheDbRow(lhd, cacheName, TCreator, dbFilter, isMulti, lang);
            return ret;
        });
    }
    static removeCacheJoinDbRow_AOP(req, res, cacheKeyPrefix, cacheName, replacements) {
        return __awaiter(this, void 0, void 0, function* () {
            const { lhd, lang } = res.locals.lhd;
            const ret = yield DatabaseService_1.default.removeCacheJoinDbRow(lhd, cacheKeyPrefix, cacheName, replacements, lang);
            return ret;
        });
    }
    static getDataOneById_AOP(req, res, TCreator, id, attributes, transaction, isUsingCache) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const { lhd, lang } = res.locals.lhd;
            const ret = yield DatabaseService_1.default.getDataOneById(lhd, TCreator, id, attributes, transaction, lang, isUsingCache);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_a = res.locals) === null || _a === void 0 ? void 0 : _a.lang);
            }
            return ret;
        });
    }
    static getDatasByIds_AOP(req, res, TCreator, ids, attributes, transaction, order) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDatasByIds(lhd, TCreator, ids, attributes, transaction, order);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static countDatasByIds_AOP(req, res, TCreator, ids, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.countDatasByIds(lhd, TCreator, ids, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static getDataOneByRid_AOP(req, res, TCreator, rid, attributes, transaction, isUsingCache) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const { lhd, lang } = res.locals.lhd;
            const ret = yield DatabaseService_1.default.getDataOneByRid(lhd, TCreator, rid, attributes, transaction, lang, isUsingCache);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_a = res.locals) === null || _a === void 0 ? void 0 : _a.lang);
            }
            return ret;
        });
    }
    static getDatasByRids_AOP(req, res, TCreator, rids, attributes, transaction, order) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDatasByRids(lhd, TCreator, rids, attributes, transaction, order);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static countDatasByRids_AOP(req, res, TCreator, rids, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.countDatasByRids(lhd, TCreator, rids, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static getDataOneByFilter_AOP(req, res, TCreator, filter, attributes, transaction, order, isUsingCache) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const { lhd, lang } = res.locals.lhd;
            const ret = yield DatabaseService_1.default.getDataOneByFilter(lhd, TCreator, filter, attributes, transaction, order, lang, isUsingCache);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_a = res.locals) === null || _a === void 0 ? void 0 : _a.lang);
            }
            return ret;
        });
    }
    static getDatasByFilter_AOP(req, res, TCreator, filter, attributes, transaction, order, offset, limit) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDatasByFilter(lhd, TCreator, filter, attributes, transaction, order, offset, limit);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static countDatasByFilter_AOP(req, res, TCreator, filter, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.countDatasByFilter(lhd, TCreator, filter, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static getDataMapByKeyArray_AOP(req, res, keys, VCreator, colName, mapKey, cols, toCond, transaction) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDataMapByKeyArray(lhd, keys, VCreator, colName, mapKey, cols, toCond, transaction);
            return ret;
        });
    }
    static changeListOrder_AOP(req, res, rdb, TCreator, rawQuery, replacements, srcId, srcListOrder, destListOrder, transaction) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.changeListOrder(lhd, rdb, TCreator, rawQuery, replacements, srcId, srcListOrder, destListOrder, transaction);
            return ret;
        });
    }
    static changeListOrderV2_AOP(req, res, rdb, TCreator, srcRid, destRid, rawQueryPart, replacements, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.changeListOrderV2(lhd, rdb, TCreator, srcRid, destRid, rawQueryPart, replacements, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static createDataWithListOrder_AOP(req, res, TCreator, newData, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.createDataWithListOrder(lhd, TCreator, newData, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static createData_AOP(req, res, newData, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.createData(lhd, newData, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static updateData_AOP(req, res, TCreate, modData, where, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.updateData(lhd, TCreate, modData, where, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static deleteData_AOP(req, res, TCreate, where, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.deleteData(lhd, TCreate, where, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
    static incrementData_AOP(req, res, TCreate, where, cols, by, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.incrementData(lhd, TCreate, where, cols, by, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
        });
    }
    static getDataByRawQuery_AOP(req, res, rawQuery, rdb, replacements, transaction) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const lhd = ((_a = res.locals) === null || _a === void 0 ? void 0 : _a.lhd) || ck_lib_1.CkValue.getDefaultLogKey(true);
            const ret = yield DatabaseService_1.default.getDataByRawQuery(lhd, rawQuery, rdb, replacements, transaction);
            if (typeof ret === 'string') {
                throw new ck_lib_1.CkError(lhd, ret, 500, undefined, (_b = res.locals) === null || _b === void 0 ? void 0 : _b.lang);
            }
            return ret;
        });
    }
}
exports.default = DatabaseWebService;
